<?php

$themename = "TAKTEEK01";
$shortname = "theme";
$options = array (
    array(  "type" => "begin",
            "name" => "Header options"),
    
    array(  "name" => "Show the header text",
            "description" => "It's disabled on default.",
            "id" => $shortname."_header_text_onoff",
            "type" => "select",
            "std" => "Disable",
            "options" => array("Enable", "Disable")),

    array(  "name" => "Header text",
            "description" => "<br />Don't use the following characters (&amp; &#060; &#062; &#047;) or the whole theme (including this page) may break! Don't use HTML!",
            "id" => $shortname."_header_text",
            "std" => "Add Text Here",
            "type" => "text"),

    array(  "type" => "close")
);

function mytheme_add_admin() {

    global $themename, $shortname, $options;

    if ( $_GET['page'] == basename(__FILE__) ) {
    
        if ( 'save' == $_REQUEST['action'] ) {

                foreach ($options as $value) {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

                foreach ($options as $value) {
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

                header("Location: themes.php?page=controlpanel.php&saved=true");
                die;

        } else if( 'reset' == $_REQUEST['action'] ) {

            foreach ($options as $value) {
                delete_option( $value['id'] ); 
                update_option( $value['id'], $value['std'] );}

            header("Location: themes.php?page=controlpanel.php&reset=true");
            die;

        }
    }

    add_theme_page($themename." Options", "TAKTEEK01 Options", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}

function mytheme_admin() {

    global $themename, $shortname, $options;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
    
?>
<div class="wrap">
<h2><?php echo $themename; ?> Theme Options</h2>

<?php foreach ($options as $value) { ?>

<form method="post">

<?php if ($value['type'] == "begin") { ?>

<h3><?php echo $value['name']; ?></h3>

<table class="form-table">

<tbody>
    
<?php } elseif ($value['type'] == "text") { ?>
        
<tr valign="top"> 
    <th scope="row"><?php echo $value['name']; ?></th>
    <td>
        <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" size="60" /> <span class="setting-description"><?php echo $value['description']; ?></span>
    </td>
</tr>
<?php } elseif ($value['type'] == "select") { ?>

    <tr valign="middle"> 
        <th scope="top"><?php echo $value['name']; ?></th>
        <td>
            <select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
                <?php foreach ($value['options'] as $option) { ?>
                <option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; }?>><?php echo $option; ?></option> 
                <?php } ?> 
            </select> <span class="setting-description"><?php echo $value['description']; ?></span>
        </td>
    </tr>
<?php } elseif ($value['type'] == "radio") { ?>

    <tr valign="middle"> 
        <th scope="top"><?php echo $value['name']; ?></th>
        <td>
                <?php foreach ($value['options'] as $option) { ?>
      <input name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php echo $option; ?>" <?php if ( get_settings( $value['id'] ) == $option) { echo 'checked'; } ?>/> <?php echo $option; echo $value['description']; ?><br />
<?php  } ?>
        </td>
    </tr>
<?php } elseif ($value['type'] == "textarea") { ?>

    <tr valign="middle"> 
        <th scope="top"><?php echo $value['name']; ?>:</th>
        <td>
            <textarea name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" cols="40" rows="5"/><?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>
</textarea>

        </td>
    </tr>
<?php } elseif ($value['type'] == "close") { ?>
</tbody>
    </table>
<?php
}
}
?>
<p class="submit">
<input class="button-primary" name="save" type="submit" value="Save changes" />    
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>
<?php
}

add_action('admin_menu', 'mytheme_add_admin'); ?>